
#include <octave/oct.h>
#include "Izhikevich03_clib.h"

void print_usage (void)
{
}

DEFUN_DLD (Izhikevich03_RS, args, nargout, "Izhikevich 03 RS model")
{
     int nargin = args.length ();
     double *vec;
     char *libargs = "";

     octave_value retval;
     
     if (nargin != 2)
     {
	  print_usage ();
	  return octave_value_list ();
     }
     else
     {
	  NDArray A = args(1).array_value ();
	  double tmax = args(0).scalar_value();

	  Izhikevich03_clib_open(0,(const char **)&libargs);

	  vec = A.fortran_vec();
	  RS_run (tmax, vec);

	  Izhikevich03_clib_close();

	  return octave_value (A);
     }
}
